<?php
 class mysql{

  private $db_host;
  private $db_user;
  private $db_pwd;
  private $db_database;
  private $conn;
  private $sql;
  private $result;
  private $coding;
  private $show_error = true;

  /**
   * 构造函数
   *
   * @access public
   * @parameter string $db_host   数据库主机
   * @parameter string $db_user   数据库用户名
   * @parameter string $db_pwd    数据库密码
   * @parameter string $db_database   数据库名
   * @parameter string $coding    编码
   * @return void
   */
  public function __construct($db_host, $db_user, $db_pwd, $db_database, $coding){
   $this->db_host = $db_host;
   $this->db_user = $db_user;
   $this->db_pwd =  $db_pwd;
   $this->db_database = $db_database;
   $this->coding = $coding;
   $this->connect();
  }

  /**
   * 链接数据库
   *
   * @access private
   * @return void
   */
  private function connect(){

   $this->conn = @mysql_connect($this->db_host,$this->db_user,$this->db_pwd);
   if(!$this->conn){
    //show_error开启时,打印错误
    if($this->show_error){
     $this->show_error('错误提示：链接数据库失败！');
    }
   }

   if(!@mysql_select_db($this->db_database, $this->conn)){
    //打开数据库失败
    if($this->show_error){
     $this->show_error('错误提示：打开数据库失败！');
    }
   }

   if(!@mysql_query("set names $this->coding")){
    //设置编码失败
    if($this->show_error){
     $this->show_error('错误提示：设置编码失败！');
    }
   }
  }

  /**
   * 可执行查询添加修改删除等任何sql语句
   *
   * @access public
   * @parameter string $sql   sql语句
   * @return resource  资源标识符
   */
  public function query($sql){
   $this->sql = $sql;
   $result = mysql_query($this->sql, $this->conn);
   if(!$result){
    //query执行失败,打印错误
    $this->show_error('数据调用设置有误', $this->sql);
   }else{
    //返回资源标识符
    return $this->result = $result;
   }
  }

  /**
   * 查询mysql服务器中所有的数据库
   *
   * @access public
   * @return void
   */
  public function show_databases(){
   $this->query("show databases");
   //打印数据库的总数
   echo "现有数据库：" . mysql_num_rows($this->result);
   echo "<br />";
   $i = 1;
   //循环输出每个数据库的名称
   while($row=mysql_fetch_array($this->result)){
    echo "$i $row[database]" . "<br />";
    $i++;
   }
  }

  /**
   * 查询数据库下所有表名
   *
   * @access public
   * @return void
   */
  public function show_tables(){
   $this->query("show tables");
   //循环输出每个表的名称
   while($row=mysql_fetch_array($this->result)){
    $m[] = $row[0];
    
   }
   return $m;
  }

  /**
   * 取得记录集,获取数组-索引和关联
   *
    * @access public
   * @return void
   */
  public function fetch_array(){
   return mysql_fetch_array($this->result);
  }

  /**
   * 简化select查询语句
   *
   * @access public
   * @parameter string $table  表名
   * @parameter string $field  字段名
   * @return resource
   */
  public function findall($table, $field = '*') {
   return $this->query("select $field from $table");
  }

  /**
   * 简化delete查询语句
   *
   * @access public
   * @parameter string $table    表名
   * @parameter string $condition  查询的条件
   * @return resource
   */
  public function delete($table, $condition) {
   return $this->query("delete from $table where $condition");
  }

  /**
   * 简化insert插入语句
   *
   * @access public
   * @parameter string $table  表名
   * @parameter string $field  字段名
   * @parameter string $value  插入值
   * @return resource
   */
  public function insert($table, $field, $value) {
   return $this->query("insert into $table ($field) values ('$value')");
  }

  /**
   * 简化update插入语句
   *
   * @access public
   * @parameter string $table      表名
   * @parameter string $update_content  更新的内容
   * @parameter string $condition    条件
   * @return resource
   */
  public function update($table, $update_content, $condition) {


   return $this->query("update $table set $update_content where $condition");
  }

  /**
   * 取得上一步 insert 操作产生的 id
   *
   * @access public
   * @return integer
   */
  public function insert_id() {
   return mysql_insert_id();
  }

  /**
   * 计算结果集条数
   *
   * @access public
   * @return integer
   */
  public function num_rows() {
   return mysql_num_rows($this->result);
  }

  /**
   * 查询字段数量和字段信息
   *
   * @access public
   * @parameter string $table  表名
   * @return void
   */
  public function num_fields($table,$i='1') {
   $this->query("select * from $table");
   $total = mysql_num_fields($this->result);
   if ($i==1){
   $m = $total;
   }else{
   for ($i = 0; $i < $total; $i++) {
   $m.= "[<a href='javascript:void(0);'>".mysql_field_name($this->result, $i)."</a>] ";
   
   }
  }
  return $m;
  }

  /**
   * 输出sql语句错误信息
   *
   * @access public
   * @parameter string $message 提示信息
   * @return void
   */
  public function show_error($message='',$sql=''){
   //echo "<div style='font-size:12px; clear:both; font-family:verdana, arial, helvetica, sans-serif;'>";
   //echo $message.' <a href="http://www.phpleft.com/?error='.mysql_error().'" title="'.mysql_error().'" target="_blank">数据库出错，请联系管理员</a>';
   //打印错误原因
   //echo "错误原因：".  . mysql_error() . "";
   //打印错误信息
   //mysql_error() 函数返回上一个 mysql 操作产生的文本错误信息。
  // echo "<div style='height:20px; background:#ff0000; border:1px #ff0000 solid'>";
   //echo "</div>";
   //打印错误sql语句
   //echo "<font color='red'><pre>" . $sql . "</pre></font>";
   //echo "</div>";
   //error_reporting(0);
  
  }
 }
 
 ?>